% SV Regression
close all;
clear all;
randn('seed', 0);
rand('seed', 0);

N = 50;

X = rand(N, 1);
y = -2*X + 5*X.^2 + sin(5*X) + 0.1*randn(N,1);

eps = 0.1;
c = 4;

% Parameters for the Kernel
h = 0.5;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Construct the rbf Kernel here.
% You should return Kij = exp( ||x_i - x_j||^2/(2h^2) )
Krbf = rbfKernel(X, X, h);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Solve the Dual problem
% You should return any information you will need to obtain predictions in the
% struct params and the support vectors in svs. svs should be a matrix with 1
% if a point is a support vector and 0 otherwise.
[params_linear, svs_linear] = dualSVMRegression(X*X', y, c, eps); 
[params_rbf, svs_rbf] = dualSVMRegression(Krbf, y, c, eps); 

% Obtain the predictions
t = linspace(0,1)';
preds_linear = dualSVMPredict(params_linear, X*t');
preds_rbf = dualSVMPredict(params_rbf, rbfKernel(X, t, h));

% Now plot the estimate and the support vectors
% Linear
figure;
plot( X(~svs_linear), y(~svs_linear), 'bo'); hold on,
plot( X(svs_linear), y(svs_linear), 'rx'); 
plot( t, preds_linear, 'b'); 
title('Linear Kernel');
% RBF
figure;
plot( X(~svs_rbf), y(~svs_rbf), 'bo'); hold on,
plot( X(svs_rbf), y(svs_rbf), 'rx'); 
plot( t, preds_rbf, 'b'); 
title('RBF Kernel');

